home *** CD-ROM | disk | FTP | other *** search
Text File | 1991-03-03 | 26.6 KB | 1,290 lines |
- #! /bin/sh
- #
- # If these # comments don't work, trim them. Don't worry about any
- # other shell scripts, Configure will trim # comments from them for you.
- #
- # (If you are trying to port this package to a machine without sh, I'd
- # suggest you cut out the prototypical config.h from the end of this
- # file and edit it to reflect your system. Some packages may include
- # samples of config.h for certain machines, so you might look for one
- # of those.)
- #
- # Yes, you may rip this off to use in other distribution packages.
- # (Note: this Configure script was generated automatically. Rather than
- # working with this copy of Configure, you may wish to get metaconfig.
- # Write to ram@educ.emse.fr (Raphael Manfredi) and I will send you
- # my version which slightly differs from the original written by
- # Larry Wall.)
-
- # $Id: Configure,v 2.0 91/02/19 15:48:32 ram Exp $
-
- : save PATH defined by user
- user_path=$PATH
-
- : sanity checks
- PATH='.:/bin:/usr/bin:/usr/local/bin:/usr/ucb:/usr/local:/usr/lbin'
- PATH=$PATH:'/usr/5bin:/etc:/usr/gnu/bin:/usr/new:/usr/new/bin:/usr/nbin'
- PATH=$PATH:'/sys5.3/bin:/sys5.3/usr/bin /bsd4.3/bin /bsd4.3/usr/ucb'
- PATH=$PATH:'/bsd4.3/usr/bin:/usr/bsd'
- export PATH || (echo "OOPS, this isn't sh. Desperation time. I will feed myself to sh."; sh $0; kill $$)
-
- if test ! -t 0; then
- echo "Say 'sh Configure', not 'sh <Configure'"
- exit 1
- fi
-
- (alias) >/dev/null 2>&1 && \
- echo "(I see you are using the Korn shell. Some ksh's blow up on Configure," && \
- echo "especially on exotic machines. If yours does, try the Bourne shell instead.)"
-
- if test ! -d ../UU; then
- if test ! -d UU; then
- mkdir UU
- fi
- cd UU
- fi
-
- case "$1" in
- -d) shift; fastread='yes';;
- esac
-
- d_eunice=''
- d_xenix=''
- d_bsd=''
- define=''
- eunicefix=''
- loclist=''
- expr=''
- awk=''
- sed=''
- echo=''
- cat=''
- chgrp=''
- chmod=''
- chown=''
- rm=''
- mv=''
- cp=''
- tail=''
- tr=''
- mkdir=''
- sort=''
- uniq=''
- grep=''
- trylist=''
- test=''
- inews=''
- egrep=''
- more=''
- pg=''
- Mcc=''
- vi=''
- mail=''
- bison=''
- cpp=''
- perl=''
- Log=''
- Header=''
- Id=''
- bin=''
- contains=''
- defeditor=''
- mansrc=''
- manext=''
- models=''
- split=''
- small=''
- medium=''
- large=''
- huge=''
- ccflags=''
- ldflags=''
- cc=''
- cppflags=''
- optimize=''
- n=''
- c=''
- package=''
- scriptdir=''
- spitshell=''
- shsharp=''
- sharpbang=''
- startsh=''
- sysman=''
- mailer=''
- CONFIG=''
- : set package name
- package=kit
-
- echo " "
- echo "Beginning of configuration questions for $package kit."
- : Eunice requires " " instead of "", can you believe it
- echo " "
-
- define='define'
- undef='undef'
- : change the next line if compiling for Xenix/286 on Xenix/386
- xlibpath='/usr/lib/386 /lib/386'
- libpth='/usr/lib /usr/local/lib /usr/lib/large /lib '$xlibpth' /lib/large'
- libpth=$libpth' /usr/lib/small /lib/small'
- smallmach='pdp11 i8086 z8000 i80286 iAPX286'
- rmlist='ark[1-9]isdone ark[1-9][0-9]isdone'
- trap 'echo " "; rm -f $rmlist; exit 1' 1 2 3 15
-
- : We must find out about Eunice early
- eunicefix=':'
- if test -f /etc/unixtovms; then
- eunicefix=/etc/unixtovms
- fi
- if test -f /etc/unixtovms.exe; then
- eunicefix=/etc/unixtovms.exe
- fi
-
- if ls blurfl >/dev/null 2>&1; then
- if awk '' blurfl >/dev/null 2>&1; then
- check='cat'
- else
- check='awk ""'
- fi
- else
- check='ls'
- fi
-
- : Now test for existence of everything in MANIFEST
- if test -f ../MANIFEST; then
- echo "First let's make sure your kit is complete. Checking..."
- : some grep do not return a proper exit status
- grep '^---' ../MANIFEST > .grepmani 2>/dev/null
- if test -s .grepmani; then
- (cd ..; eval $check `awk '!/^.*\/$/{if (b) print $1}
- /^---/{b=1}' MANIFEST` || kill $$) >/dev/null
- else
- (cd ..; eval $check `awk '!/^.*\/$/{print $1}' MANIFEST` || kill $$) >/dev/null
- fi
- echo "Looks good..."
- else
- echo "No MANIFEST found. Hope your kit is complete !"
- fi
- rm -f .grepmani
-
- pth="/usr/ucb /bin /usr/bin /usr/local /usr/local/bin /usr/5bin"
- pth=$pth" /usr/lbin /etc /usr/new /usr/new/bin /usr/nbin /usr/gnu/bin"
- pth=$pth" /usr/plx /vol/local/bin /usr/lib /lib /usr/local/lib"
- pth=$pth" /sys5.3/bin /sys5.3/usr/bin /bsd4.3/bin /bsd4.3/usr/bin"
- pth=$pth" /bsd4.3/usr/ucb /usr/bsd"
- : add PATH from user
- pth=$pth" "`echo $user_path | sed -e 's/:/ /g'`
- inclwanted=''
-
- : some greps do not return status, grrr.
- echo "grimblepritz" >grimble
- if grep blurfldyick grimble >/dev/null 2>&1 ; then
- contains=contains
- elif grep grimblepritz grimble >/dev/null 2>&1 ; then
- contains=grep
- else
- contains=contains
- fi
- rm -f grimble
- : the following should work in any shell
- case "$contains" in
- contains*)
- echo " "
- echo "AGH! Grep doesn't return a status. Attempting remedial action."
- cat >contains <<'EOSS'
- grep "$1" "$2" >.greptmp && cat .greptmp && test -s .greptmp
- EOSS
- chmod +x contains
- esac
-
- : see if sh knows # comments
- echo " "
- echo "Checking your sh to see if it knows about # comments..."
- if sh -c '#' >/dev/null 2>&1 ; then
- echo "Your sh handles # comments correctly."
- shsharp=true
- spitshell=cat
- echo " "
- echo "Okay, let's see if #! works on this system..."
- echo "#!/bin/echo hi" > try
- $eunicefix try
- chmod +x try
- try > today
- if $contains hi today >/dev/null 2>&1; then
- echo "It does."
- sharpbang='#!'
- else
- echo "#! /bin/echo hi" > try
- $eunicefix try
- chmod +x try
- try > today
- if test -s today; then
- echo "It does."
- sharpbang='#! '
- else
- echo "It doesn't."
- sharpbang=': use '
- fi
- fi
- else
- echo "Your sh doesn't grok # comments--I will strip them later on."
- shsharp=false
- echo "exec grep -v '^[ ]*#'" >spitshell
- chmod +x spitshell
- $eunicefix spitshell
- spitshell=`pwd`/spitshell
- echo "I presume that if # doesn't work, #! won't work either!"
- sharpbang=': use '
- fi
- rm -f try today
-
- : figure out how to guarantee sh startup
- echo " "
- echo "Checking out how to guarantee sh startup..."
- startsh=$sharpbang'/bin/sh'
- echo "Let's see if '$startsh' works..."
- cat >try <<EOSS
- $startsh
- set abc
- test "$?abc" != 1
- EOSS
-
- chmod +x try
- $eunicefix try
- if try; then
- echo "Yup, it does."
- else
- echo "Nope. You may have to fix up the shell scripts to make sure sh runs them."
- fi
- rm -f try
-
- : first determine how to suppress newline on echo command
- echo " "
- echo "Checking echo to see how to suppress newlines..."
- (echo "hi there\c" ; echo " ") >.echotmp
- if $contains c .echotmp >/dev/null 2>&1 ; then
- echo "...using -n."
- n='-n'
- c=''
- else
- cat <<'EOM'
- ...using \c
- EOM
- n=''
- c='\c'
- fi
- echo $n "The star should be here-->$c"
- echo '*'
- rm -f .echotmp
-
- : now set up to do reads with possible shell escape and default assignment
- cat <<EOSC >myread
- case "\$fastread" in
- yes) ans=''; echo " " ;;
- *) ans='!';;
- esac
- while expr "X\$ans" : "X!" >/dev/null; do
- read ans
- case "\$ans" in
- !)
- sh
- echo " "
- echo $n "\$rp $c"
- ;;
- !*)
- set \`expr "X\$ans" : "X!\(.*\)\$"\`
- sh -c "\$*"
- echo " "
- echo $n "\$rp $c"
- ;;
- esac
- done
- rp='Your answer:'
- case "\$ans" in
- '') ans="\$dflt";;
- esac
- EOSC
-
- : general instructions
- cat <<EOH
-
- This installation shell script will examine your system and ask you questions
- to determine how the $package package should be installed. If you get stuck
- on a question, you may use a ! shell escape to start a subshell or execute
- a command. Many of the questions will have default answers in square
- brackets--typing carriage return will give you the default.
-
- On some of the questions which ask for file or directory names you are
- allowed to use the ~name construct to specify the login directory belonging
- to "name", even if you don't have a shell which knows about that. Questions
- where this is allowed will be marked "(~name ok)".
-
- EOH
- rp="[Type carriage return to continue]"
- echo $n "$rp $c"
- . myread
- cat <<EOH
-
- Much effort has been expended to ensure that this shell script will run on
- any Unix system. If despite that it blows up on you, your best bet is to edit
- Configure and run it again. Also, let me (ram@educ.emse.fr)
- know how I blew it. If you can't run Configure for some reason, you'll have
- to generate a config.sh file by hand.
-
- This installation script affects things in two ways:
- 1) it may do direct variable substitutions on some of the files included
- in this kit.
- 2) it builds a config.h file for inclusion in C programs. You may edit
- any of these files as the need arises after running this script.
-
- If you make a mistake on a question, there is no easy way to back up to it
- currently. The easiest thing to do is to edit config.sh and rerun all the
- SH files. Configure will offer to let you do this before it runs the SH files.
-
- EOH
- rp="[Type carriage return to continue]"
- echo $n "$rp $c"
- . myread
-
- : get old answers, if there is a config file out there
- if test -f ../config.sh; then
- echo " "
- dflt=y
- rp="I see a config.sh file. Did Configure make it on THIS system? [$dflt]"
- echo $n "$rp $c"
- . myread
- case "$ans" in
- n*|N*) echo "OK, I'll ignore it.";;
- *) echo "Fetching default answers from your old config.sh file..."
- tmp="$n"
- ans="$c"
- . ../config.sh
- n="$tmp"
- c="$ans"
- ;;
- esac
- fi
-
- : find out where common programs are
- echo " "
- echo "Locating common programs..."
- cat <<EOSC >loc
- $startsh
- case \$# in
- 0) exit 1;;
- esac
- thing=\$1
- shift
- dflt=\$1
- shift
- for dir in \$*; do
- case "\$thing" in
- .)
- if test -d \$dir/\$thing; then
- echo \$dir
- exit 0
- fi
- ;;
- *)
- if test -f \$dir/\$thing; then
- echo \$dir/\$thing
- exit 0
- elif test -f \$dir/\$thing.exe; then
- : on Eunice apparently
- echo \$dir/\$thing
- exit 0
- fi
- ;;
- esac
- done
- echo \$dflt
- exit 1
- EOSC
- chmod +x loc
- $eunicefix loc
- loclist="
- cat
- chgrp
- chmod
- chown
- echo
- expr
- grep
- rm
- sed
- "
- trylist="
- test
- vi
- "
- for file in $loclist; do
- xxx=`loc $file $file $pth`
- eval $file=$xxx
- eval _$file=$xxx
- case "$xxx" in
- /*)
- echo $file is in $xxx.
- ;;
- *)
- echo "I don't know where $file is. I hope it's in everyone's PATH."
- ;;
- esac
- done
- echo " "
- echo "Don't worry if any of the following aren't found..."
- ans=offhand
- for file in $trylist; do
- xxx=`loc $file $file $pth`
- eval $file=$xxx
- eval _$file=$xxx
- case "$xxx" in
- /*)
- echo $file is in $xxx.
- ;;
- *)
- echo "I don't see $file out there, $ans."
- ans=either
- ;;
- esac
- done
- case "$egrep" in
- egrep)
- echo "Substituting grep for egrep."
- egrep=$grep
- ;;
- esac
- case "$test" in
- test)
- echo "Hopefully test is built into your sh."
- ;;
- /bin/test)
- if sh -c "PATH= test true" >/dev/null 2>&1; then
- echo "Using the test built into your sh."
- test=test
- fi
- ;;
- *)
- test=test
- ;;
- esac
- case "$echo" in
- echo)
- echo "Hopefully echo is built into your sh."
- ;;
- /bin/echo)
- echo " "
- echo "Checking compatibility between /bin/echo and builtin echo (if any)..."
- $echo $n "hi there$c" >foo1
- echo $n "hi there$c" >foo2
- if cmp foo1 foo2 >/dev/null 2>&1; then
- echo "They are compatible. In fact, they may be identical."
- else
- case "$n" in
- '-n') n='' c='\c' ans='\c' ;;
- *) n='-n' c='' ans='-n' ;;
- esac
- cat <<FOO
- They are not compatible! You are probably running ksh on a non-USG system.
- I'll have to use /bin/echo instead of the builtin, since Bourne shell doesn't
- have echo built in and we may have to run some Bourne shell scripts. That
- means I'll have to use $ans to suppress newlines now. Life is ridiculous.
-
- FOO
- rp="The star should be here-->"
- $echo $n "$rp$c"
- $echo "*"
- fi
- $rm -f foo1 foo2
- ;;
- *)
- : cross your fingers
- echo=echo
- ;;
- esac
- rmlist="$rmlist loc"
-
- : preserve RCS keywords in files with variable substitution, grrr
- Log='$Log'
- Header='$Header'
- Id='$Id'
-
- : set up shell script to do ~ expansion
- cat >filexp <<EOSS
- $startsh
- : expand filename
- case "\$1" in
- ~/*|~)
- echo \$1 | $sed "s|~|\${HOME-\$LOGDIR}|"
- ;;
- ~*)
- if $test -f /bin/csh; then
- /bin/csh -f -c "glob \$1"
- echo ""
- else
- name=\`$expr x\$1 : '..\([^/]*\)'\`
- dir=\`$sed -n -e "/^\${name}:/{s/^[^:]*:[^:]*:[^:]*:[^:]*:[^:]*:\([^:]*\).*"'\$'"/\1/" -e p -e q -e '}' </etc/passwd\`
- if $test ! -d "\$dir"; then
- me=\`basename \$0\`
- echo "\$me: can't locate home directory for: \$name" >&2
- exit 1
- fi
- case "\$1" in
- */*)
- echo \$dir/\`$expr x\$1 : '..[^/]*/\(.*\)'\`
- ;;
- *)
- echo \$dir
- ;;
- esac
- fi
- ;;
- *)
- echo \$1
- ;;
- esac
- EOSS
- chmod +x filexp
- $eunicefix filexp
-
- : determine where public executables go
- case "$bin" in
- '')
- dflt=`loc . /bin /usr/local/bin /usr/lbin /usr/local /usr/bin`
- ;;
- *) dflt="$bin"
- ;;
- esac
- cont=true
- while $test "$cont" ; do
- echo " "
- rp="Where do you want to put the public executables? (~name ok) [$dflt]"
- $echo $n "$rp $c"
- . myread
- bin="$ans"
- bin=`filexp $bin`
- if test -d $bin; then
- cont=''
- else
- dflt=n
- rp="Directory $bin doesn't exist. Use that name anyway? [$dflt]"
- $echo $n "$rp $c"
- . myread
- dflt=''
- case "$ans" in
- y*) cont='';;
- esac
- fi
- done
-
- : determine where manual pages are on this system
- echo " "
- case "$sysman" in
- '') sysman=`loc . /usr/man/man1 /usr/man/man1 /usr/man/mann /usr/man/manl /usr/man/local/man1 /usr/man/u_man/man1 /usr/share/man/man1 /usr/catman/u_man/man1 /usr/man/l_man/man1 /usr/local/man/u_man/man1 /usr/local/man/l_man/man1 /usr/man/man.L`
- ;;
- esac
- if test -d "$sysman"; then
- echo "System manual is in $sysman."
- fi
-
- : make some quick guesses about what we are up against
- echo " "
- $echo $n "Hmm... $c"
- cat /usr/include/signal.h /usr/include/sys/signal.h >foo 2>/dev/null
- if test `echo abc | tr a-z A-Z` = Abc ; then
- if $contains SIGTSTP foo >/dev/null 2>&1 ; then
- echo "Looks kind of like an USG system with BSD features, but we'll see..."
- else
- echo "Looks kind of like an USG system, but we'll see..."
- fi
- d_bsd="$undef"
- echo exit 1 >bsd
- echo exit 0 >usg
- echo exit 1 >v7
- elif $contains SIGTSTP foo >/dev/null 2>&1 ; then
- echo "Looks kind of like a BSD system, but we'll see..."
- d_bsd="$define"
- echo exit 0 >bsd
- echo exit 1 >usg
- echo exit 1 >v7
- else
- echo "Looks kind of like a Version 7 system, but we'll see..."
- d_bsd="$undef"
- echo exit 1 >bsd
- echo exit 1 >usg
- echo exit 0 >v7
- fi
- case "$eunicefix" in
- *unixtovms*)
- cat <<'EOI'
- There is, however, a strange, musty smell in the air that reminds me of
- something...hmm...yes...I've got it...there's a VMS nearby, or I'm a Blit.
- EOI
- echo "exit 0" >eunice
- eunicefix=unixtovms
- d_eunice="$define"
- : it so happens the Eunice I know will not run shell scripts in Unix format
- ;;
- *)
- echo " "
- echo "Congratulations. You aren't running Eunice."
- eunicefix=':'
- d_eunice="$undef"
- echo "exit 1" >eunice
- ;;
- esac
- if test -f /xenix; then
- echo "Actually, this looks more like a XENIX system..."
- echo "exit 0" >xenix
- d_xenix="$define"
- else
- echo " "
- echo "It's not Xenix..."
- echo "exit 1" >xenix
- d_xenix="$undef"
- fi
- chmod +x xenix
- $eunicefix xenix
- if test -f /venix; then
- echo "Actually, this looks more like a VENIX system..."
- echo "exit 0" >venix
- else
- echo " "
- if xenix; then
- : null
- else
- echo "Nor is it Venix..."
- fi
- echo "exit 1" >venix
- fi
- chmod +x bsd usg v7 eunice venix
- $eunicefix bsd usg v7 eunice venix
- rm -f foo
- rmlist="$rmlist bsd usg v7 eunice venix xenix"
-
- : see what memory models we can support
- case "$models" in
- '')
- cat >pdp11.c <<'EOP'
- main() {
- #ifdef pdp11
- exit(0);
- #else
- exit(1);
- #endif
- }
- EOP
- cc -o pdp11 pdp11.c >/dev/null 2>&1
- if pdp11 2>/dev/null; then
- dflt='unsplit split'
- else
- ans=`loc . X /lib/small /lib/large /usr/lib/small /usr/lib/large /lib/medium /usr/lib/medium /lib/huge`
- case "$ans" in
- X) dflt='none';;
- *) if $test -d /lib/small || $test -d /usr/lib/small; then
- dflt='small'
- else
- dflt=''
- fi
- if $test -d /lib/medium || $test -d /usr/lib/medium; then
- dflt="$dflt medium"
- fi
- if $test -d /lib/large || $test -d /usr/lib/large; then
- dflt="$dflt large"
- fi
- if $test -d /lib/huge || $test -d /usr/lib/huge; then
- dflt="$dflt huge"
- fi
- esac
- fi;;
- *) dflt="$models";;
- esac
- $cat <<EOM
-
- Some systems have different model sizes. On most systems they are called
- small, medium, large, and huge. On the PDP11 they are called unsplit and
- split. If your system doesn't support different memory models, say "none".
- If you wish to force everything to one memory model, say "none" here and
- put the appropriate flags later when it asks you for other cc and ld flags.
- Venix systems may wish to put "none" and let the compiler figure things out.
- (In the following question multiple model names should be space separated.)
-
- EOM
- rp="Which models are supported? [$dflt]"
- $echo $n "$rp $c"
- . myread
- models="$ans"
-
- case "$models" in
- none)
- small=''
- medium=''
- large=''
- huge=''
- unsplit=''
- split=''
- ;;
- *split)
- case "$split" in
- '') if $contains '\-i' $mansrc/ld.1 >/dev/null 2>&1 || \
- $contains '\-i' $mansrc/cc.1 >/dev/null 2>&1; then
- dflt='-i'
- else
- dflt='none'
- fi;;
- *) dflt="$split";;
- esac
- rp="What flag indicates separate I and D space? [$dflt]"
- $echo $n "$rp $c"
- . myread
- case "$ans" in
- none) ans='';;
- esac
- split="$ans"
- unsplit='';;
- *large*|*small*|*medium*|*huge*)
- case "$model" in
- *large*)
- case "$large" in
- '') dflt='-Ml';;
- *) dflt="$large";;
- esac
- rp="What flag indicates large model? [$dflt]"
- $echo $n "$rp $c"
- . myread
- case "$ans" in
- none) ans='';
- esac
- large="$ans";;
- *) large='';;
- esac
- case "$model" in
- *huge*) case "$huge" in
- '') dflt='-Mh';;
- *) dflt="$huge";;
- esac
- rp="What flag indicates huge model? [$dflt]"
- $echo $n "$rp $c"
- . myread
- case "$ans" in
- none) ans='';
- esac
- huge="$ans";;
- *) huge="$large";;
- esac
- case "$model" in
- *medium*) case "$medium" in
- '') dflt='-Mm';;
- *) dflt="$medium";;
- esac
- rp="What flag indicates medium model? [$dflt]"
- $echo $n "$rp $c"
- . myread
- case "$ans" in
- none) ans='';
- esac
- medium="$ans";;
- *) medium="$large";;
- esac
- case "$model" in
- *small*) case "$small" in
- '') dflt='none';;
- *) dflt="$small";;
- esac
- rp="What flag indicates small model? [$dflt]"
- $echo $n "$rp $c"
- . myread
- case "$ans" in
- none) ans='';
- esac
- small="$ans";;
- *) small='';;
- esac
- ;;
- *)
- echo "Unrecognized memory models--you may have to edit Makefile.SH"
- ;;
- esac
-
- : see if we need a special compiler
- echo " "
- if usg; then
- case "$cc" in
- '')
- case "$Mcc" in
- /*) dflt='Mcc'
- ;;
- *)
- case "$large" in
- -M*)
- dflt='cc'
- ;;
- *)
- if $contains '\-M' $mansrc/cc.1 >/dev/null 2>&1 ; then
- dflt='cc -M'
- else
- dflt='cc'
- fi
- ;;
- esac
- ;;
- esac
- ;;
- *) dflt="$cc";;
- esac
- $cat <<'EOM'
-
- On some systems the default C compiler will not resolve multiple global
- references that happen to have the same name. On some such systems the
- "Mcc" command may be used to force these to be resolved. On other systems
- a "cc -M" command is required. (Note that the -M flag on other systems
- indicates a memory model to use!) If you have the Gnu C compiler, you
- might wish to use that instead. What command will force resolution on
- EOM
- $echo $n "this system? [$dflt] $c"
- rp="Command to resolve multiple refs? [$dflt]"
- . myread
- cc="$ans"
- else
- case "$cc" in
- '') dflt=cc;;
- *) dflt="$cc";;
- esac
- rp="Use which C compiler? [$dflt]"
- $echo $n "$rp $c"
- . myread
- cc="$ans"
- fi
- case "$cc" in
- gcc*) cpp=`loc gcc-cpp $cpp $pth`;;
- esac
-
- : determine optimize, if desired, or use for debug flag also
- case "$optimize" in
- ' ') dflt="none";;
- '') dflt="-O";;
- *) dflt="$optimize";;
- esac
- cat <<EOH
-
- Some C compilers have problems with their optimizers, by default, $package
- compiles with the -O flag to use the optimizer. Alternately, you might
- want to use the symbolic debugger, which uses the -g flag (on traditional
- Unix systems). Either flag can be specified here. To use neither flag,
- specify the word "none".
-
- EOH
- rp="What optimizer/debugger flag should be used? [$dflt]"
- $echo $n "$rp $c"
- . myread
- optimize="$ans"
- case "$optimize" in
- 'none') optimize=" ";;
- esac
-
- case "$ccflags" in
- '') case "$cc" in
- *gcc*) dflt='-fpcc-struct-return';;
- *) dflt='';;
- esac
- ;;
- *) dflt="$ccflags";;
- esac
- for thisincl in $inclwanted; do
- if $test -d $thisincl; then
- case "$dflt" in
- *$thisincl*);;
- *) dflt="$dflt -I$thisincl";;
- esac
- fi
- done
- case "$optimize" in
- -g*)
- case "$dflt" in
- *DEBUG*);;
- *) dflt="$dflt -DDEBUG";;
- esac
- ;;
- esac
- if $contains 'LANGUAGE_C' /usr/include/signal.h >/dev/null 2>&1; then
- case "$dflt" in
- *LANGUAGE_C*);;
- *) dflt="$dflt -DLANGUAGE_C";;
- esac
- fi
- case "$dflt" in
- '') dflt=none;;
- esac
- cat <<EOH
-
- Your C compiler may want other flags. For this question you should
- include -I/whatever and -DWHATEVER flags and any other flags used by
- the C compiler, but you should NOT include libraries or ld flags like
- -lwhatever. To use no flags, specify the word "none".
-
- EOH
- rp="Any additional cc flags? [$dflt]"
- $echo $n "$rp $c"
- . myread
- case "$ans" in
- none) ans='';
- esac
- ccflags="$ans"
-
- : the following weeds options from ccflags that are of no interest to cpp
- cppflags="$ccflags"
- case "$cc" in
- *gcc*) cppflags="$cppflags -D__GNUC__";;
- esac
- case "$cppflags" in
- '');;
- *) set X $cppflags
- cppflags=''
- for flag do
- case $flag in
- -D*|-I*) cppflags="$cppflags $flag";;
- esac
- done
- case "$cppflags" in
- *-*) echo "(C preprocessor flags: $cppflags)";;
- esac
- ;;
- esac
-
- case "$ldflags" in
- '') if venix; then
- dflt='-i -z'
- else
- dflt='none'
- fi
- ;;
- *) dflt="$ldflags";;
- esac
- echo " "
- rp="Any additional ld flags (NOT including libraries)? [$dflt]"
- $echo $n "$rp $c"
- . myread
- case "$ans" in
- none) ans='';
- esac
- ldflags="$ans"
- rmlist="$rmlist pdp11"
-
- : determine default editor
- case "$defeditor" in
- '')
- case "$_vi" in
- */*) dflt="$_vi";;
- *) dflt=/usr/ucb/vi;;
- esac
- ;;
- *) dflt="$defeditor"
- ;;
- esac
- cont=true
- while $test "$cont" ; do
- echo " "
- rp="What is the default editor on your system? [$dflt]"
- $echo $n "$rp $c"
- . myread
- defeditor="$ans"
- if test -f $ans; then
- cont=''
- else
- dflt=n
- rp="File $ans doesn't exist. Use that name anyway? [$dflt]"
- $echo $n "$rp $c"
- . myread
- dflt=''
- case "$ans" in
- y*) cont='';;
- esac
- fi
- done
-
- : determine the name of a reasonable mailer
- case "$mailer" in
- '')
- if $test -f /usr/lib/sendmail; then
- dflt="/usr/lib/sendmail -odi"
- elif $test -f /bin/mail; then
- dflt=/bin/mail
- else
- dflt=$mail
- fi
- ;;
- *) dflt="$mailer";;
- esac
- cont=true
- while $test "$cont" ; do
- echo " "
- echo "Give the full path name of the program used to deliver mail on your"
- $echo $n "system: [$dflt] $c"
- rp="Preferred mailer: [$dflt]"
- . myread
- mailer="$ans"
- set x $ans
- shift
- if test -f "$1"; then
- cont=''
- else
- dflt=n
- rp="File $ans doesn't exist. Use that name anyway? [$dflt]"
- $echo $n "$rp $c"
- . myread
- dflt=''
- case "$ans" in
- y*) cont='';;
- esac
- fi
- done
-
- : determine where manual pages go
- case "$mansrc" in
- '')
- dflt="$sysman"
- ;;
- *) dflt="$mansrc"
- ;;
- esac
- cont=true
- while $test "$cont" ; do
- echo " "
- rp="Where do the manual pages (source) go? (~name ok) [$dflt]"
- $echo $n "$rp $c"
- . myread
- mansrc=`filexp "$ans"`
- if test -d "$mansrc"; then
- cont=''
- else
- dflt=n
- rp="Directory $mansrc doesn't exist. Use that name anyway? [$dflt]"
- $echo $n "$rp $c"
- . myread
- dflt=''
- case "$ans" in
- y*) cont='';;
- esac
- fi
- done
- case "$mansrc" in
- *l)
- manext=l
- ;;
- *n)
- manext=n
- ;;
- *C)
- manext=C
- ;;
- *)
- manext=1
- ;;
- esac
-
- : determine where public executables go
- case "$scriptdir" in
- '')
- dflt="$bin"
- : guess some guesses
- $test -d /usr/share/scripts && dflt=/usr/share/scripts
- $test -d /usr/share/bin && dflt=/usr/share/bin
- ;;
- *) dflt="$scriptdir"
- ;;
- esac
- cont=true
- $cat <<EOM
-
- Some installations have a separate directory just for executable scripts so
- that they can mount it across multiple architectures but keep the scripts in
- one spot. You might, for example, have a subdirectory of /usr/share for this.
- Or you might just lump your scripts in with all your other executables.
-
- EOM
- while $test "$cont" ; do
- rp="Where do you keep publicly executable scripts? (~name ok) [$dflt]"
- $echo $n "$rp $c"
- . myread
- scriptdir="$ans"
- scriptdir=`./filexp "$scriptdir"`
- if $test -d $scriptdir; then
- cont=''
- else
- case "$fastread" in
- yes) dflt=y;;
- *) dflt=n;;
- esac
- rp="Directory $scriptdir doesn't exist. Use that name anyway? [$dflt]"
- $echo $n "$rp $c"
- . myread
- dflt=''
- case "$ans" in
- y*) cont='';;
- esac
- fi
- done
-
- echo " "
- echo "End of configuration questions."
- echo " "
-
- : create config.sh file
- echo " "
- if test -d ../UU; then
- cd ..
- fi
- echo "Creating config.sh..."
- $spitshell <<EOT >config.sh
- $startsh
- # config.sh
- # This file was produced by running the Configure script.
-
- d_eunice='$d_eunice'
- d_xenix='$d_xenix'
- d_bsd='$d_bsd'
- define='$define'
- eunicefix='$eunicefix'
- loclist='$loclist'
- expr='$expr'
- awk='$awk'
- sed='$sed'
- echo='$echo'
- cat='$cat'
- chgrp='$chgrp'
- chmod='$chmod'
- chown='$chown'
- rm='$rm'
- mv='$mv'
- cp='$cp'
- tail='$tail'
- tr='$tr'
- mkdir='$mkdir'
- sort='$sort'
- uniq='$uniq'
- grep='$grep'
- trylist='$trylist'
- test='$test'
- inews='$inews'
- egrep='$egrep'
- more='$more'
- pg='$pg'
- Mcc='$Mcc'
- vi='$vi'
- mail='$mail'
- bison='$bison'
- cpp='$cpp'
- perl='$perl'
- Log='$Log'
- Header='$Header'
- Id='$Id'
- bin='$bin'
- contains='$contains'
- defeditor='$defeditor'
- mansrc='$mansrc'
- manext='$manext'
- models='$models'
- split='$split'
- small='$small'
- medium='$medium'
- large='$large'
- huge='$huge'
- ccflags='$ccflags'
- ldflags='$ldflags'
- cc='$cc'
- cppflags='$cppflags'
- optimize='$optimize'
- n='$n'
- c='$c'
- package='$package'
- scriptdir='$scriptdir'
- spitshell='$spitshell'
- shsharp='$shsharp'
- sharpbang='$sharpbang'
- startsh='$startsh'
- sysman='$sysman'
- mailer='$mailer'
- CONFIG=true
- EOT
-
- CONFIG=true
-
- echo " "
- dflt=''
- fastread=''
- echo "If you didn't make any mistakes, then just type a carriage return here."
- rp="If you need to edit config.sh, do it as a shell escape here:"
- $echo $n "$rp $c"
- . UU/myread
- case "$ans" in
- '') ;;
- *) : in case they cannot read
- eval $ans;;
- esac
- . ./config.sh
-
- echo " "
- echo "Doing variable substitutions on .SH files..."
- if test -f MANIFEST; then
- set x `awk '{print $1}' <MANIFEST | $grep '\.SH'`
- else
- set x `find . -name "*.SH" -print`
- fi
- shift
- case $# in
- 0) set x *.SH; shift;;
- esac
- if test ! -f $1; then
- shift
- fi
- for file in $*; do
- case "$file" in
- */*)
- dir=`$expr X$file : 'X\(.*\)/'`
- file=`$expr X$file : 'X.*/\(.*\)'`
- (cd $dir && . $file)
- ;;
- *)
- . $file
- ;;
- esac
- done
- if test -f config.h.SH; then
- if test ! -f config.h; then
- : oops, they left it out of MANIFEST, probably, so do it anyway.
- . config.h.SH
- fi
- fi
-
- if $contains '^depend:' Makefile >/dev/null 2>&1; then
- dflt=n
- $cat <<EOM
-
- Now you need to generate make dependencies by running "make depend".
- You might prefer to run it in background: "make depend > makedepend.out &"
- It can take a while, so you might not want to run it right now.
-
- EOM
- rp="Run make depend now? [$dflt]"
- $echo $n "$rp $c"
- . UU/myread
- case "$ans" in
- y*) make depend
- echo "Now you must run a make."
- ;;
- *) echo "You must run 'make depend' then 'make'."
- ;;
- esac
- elif test -f Makefile; then
- echo " "
- echo "Now you must run a make."
- else
- echo "Done."
- fi
-
- $rm -f kit*isdone
- : the following is currently useless
- cd UU && $rm -f $rmlist
- : since this removes it all anyway
- cd .. && $rm -rf UU
- : end of Configure
-